// Generated by dts-bundle-generator v9.5.1

import { LanguageRegistration, ThemeRegistration, ThemeRegistrationRaw } from 'shiki';
import { ComponentProps, JSX } from 'solid-js';

/**********************************************************************************/
/**********************************************************************************/
export interface ShikiTextareaProps extends Omit<ComponentProps<"div">, "style" | "onInput" | "lang"> {
	/** The default source code to initialize the editor with. */
	defaultValue?: string;
	/**
	 * The programming language of the source code for syntax highlighting.
	 *
	 * @example static import
	 * ```tsx
	 * import tsx from "shiki/langs/tsx.mjs"
	 * return <ShikiTextArea lang={tsx}/>
	 * ```
	 * @example dynamic import
	 * ```tsx
	 * return <ShikiTextArea lang={import('shiki/langs/tsx.mjs')}/>
	 * ```
	 */
	lang: Promise<LanguageRegistration[]> | Promise<{
		default: LanguageRegistration[];
	}> | LanguageRegistration[];
	/** Custom CSS properties to apply to the editor. */
	style?: JSX.CSSProperties;
	/**
	 * The theme to apply for syntax highlighting.
	 *
	 * @example static import
	 * ```tsx
	 * import andromeeda from "shiki/theme/andromeeda.mjs"
	 * return <ShikiTextArea theme={andromeeda}/>
	 * ```
	 * @example dynamic import
	 * ```tsx
	 * return <ShikiTextArea theme={import('shiki/theme/andromeeda.mjs')}/>
	 * ```
	 */
	theme: Promise<ThemeRegistrationRaw | ThemeRegistration> | Promise<{
		default: ThemeRegistrationRaw | ThemeRegistration;
	}> | ThemeRegistrationRaw | ThemeRegistration;
	/** The source code to be displayed and edited. */
	value: string;
	/** Callback function to handle updates to the source code. */
	onInput?: (source: string) => void;
}
/**
 * A textarea with syntax highlighting capabilities powered by [shiki](https://github.com/shikijs/shiki).
 *
 * @example static import
 * ```tsx
 * import andromeeda from "shiki/themes/andromeeda.mjs"
 * import tsx from "shiki/langs/tsx.mjs"
 * return (
 *  <ShikiTextArea
 *    theme={andromeeda}
 *    lang={tsx}
 *  />
 * )
 * ```
 * @example dynamic import
 * ```tsx
 * return (
 *  <ShikiTextArea
 *    theme={import('shiki/themes/andromeeda.mjs')}
 *    lang={import('shiki/langs/tsx.mjs')}
 *  />
 * )
 * ```
 */
export declare function ShikiTextarea(props: ShikiTextareaProps): JSX.Element;

export {};
